package com.bewo.admedia;

import android.annotation.TargetApi;
import android.hardware.display.DisplayManager;
import android.os.Build;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.view.Display;
import android.view.View;

import com.bewo.admedia.adscreens.AdScreenHDMIDisplay;


public class BillingActivity extends ActionBarActivity implements View.OnClickListener {

    AdScreenHDMIDisplay adScreen;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_billing);
    }

    @TargetApi(Build.VERSION_CODES.JELLY_BEAN_MR1)
    @Override
    public void onStart() {
        super.onStart();
        DisplayManager dm = (DisplayManager) getSystemService(DISPLAY_SERVICE);
        if (dm != null){
            final Display[] displays = dm.getDisplays(DisplayManager.DISPLAY_CATEGORY_PRESENTATION);

            System.out.println("Display available: "+displays.length);

            for (Display display : displays){
                adScreen = new AdScreenHDMIDisplay(this, display);
            }
        }
    }

    @Override
    protected void onDestroy() {
        // TODO Auto-generated method stub
        super.onDestroy();
        if(adScreen.isShowing())
            adScreen.dismiss();
    }

    @TargetApi(Build.VERSION_CODES.JELLY_BEAN_MR1)
    @Override
    public void onClick(View v) {
        switch(v.getId()) {
            case R.id.btn_startAdScreen:
               adScreen.show();
                break;

            case R.id.btn_stopAdScreen:
                if(adScreen.isShowing())
                    adScreen.dismiss();
                break;

            case R.id.btn_play:
                break;

            case R.id.btn_pause:
                break;

            case R.id.btn_prev:
                break;

            case R.id.btn_next:
                break;
        }
    }
}
