package com.bewo.admedia.adscreens;

import android.annotation.TargetApi;
import android.app.Presentation;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.media.MediaPlayer;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.util.Log;
import android.view.Display;
import android.widget.MediaController;
import android.widget.VideoView;

import com.bewo.admedia.R;
import com.bewo.admedia.utils.AppConstants;

import java.io.File;
import java.io.FileNotFoundException;

/**
 * Created by raj.
 */
@TargetApi(Build.VERSION_CODES.JELLY_BEAN_MR1)
public class AdScreenHDMIDisplay extends Presentation {

    private static final String TAG = "BeWoAdMedia v1.r1";

    Context innerContext;

    public AdScreenHDMIDisplay(Context outerContext, Display display) {
        super(outerContext, display);
        innerContext = outerContext;
    }

    @Override
    public void dismiss() {
        // TODO Auto-generated method stub
        super.dismiss();
    }

    @Override
    public void show() {
        // TODO Auto-generated method stub
        super.show();
    }

    private Handler imageSlideHandler;
    private String dirPath = AppConstants.AdImagesPath;
    private final int INIT_DELAY = 0;
    private final int DELAY = 3000;	 /*** 3 Sec ***/
    private int imgPosition = 0;

    private VideoView videoView = null;
    //private TextView textView = null;
    private String[] video_array;
    File videoFolderPath;
    File videoFile;
    Uri uri;
    int currentVideoPosition = 0;
    private boolean deleteCurrentVideo = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_adscreen_hdmi);

        videoView = (VideoView) findViewById(R.id.adVideo);

        /*final ImageView sdCardImages = (ImageView) findViewById(R.id.sliding_images);
        final Animation anim = AnimationUtils.loadAnimation(innerContext, R.anim.l2ramin);

        *//*** Fetch images from SD Card ***//*

        final ArrayList<String> images = new ArrayList<String>();  // list of file paths

        try{

            File imgDir = new File(dirPath);

            for(File image : imgDir.listFiles()) {
                images.add(image.getAbsolutePath());
            }

        } catch(Exception e){
            e.printStackTrace();
            Toast.makeText(innerContext, "Dir not found", Toast.LENGTH_LONG).show();
        }*/

        /*** Load image for every 2sec ***/

        /*imageSlideHandler = new Handler();

        imageSlideHandler.postDelayed(new Runnable() {
            @Override
            public void run() {

                try{

                    if(imgPosition >= images.size()){
                        imgPosition = 0;
                    }

                    Bitmap imgBitmap = getBitmapFromPath(images.get(imgPosition));

                    if(imgBitmap != null){
                        sdCardImages.setImageBitmap(imgBitmap);

                        sdCardImages.startAnimation(anim);
                    }

                    imgPosition++;
                    imageSlideHandler.postDelayed(this, DELAY);

                } catch (FileNotFoundException e){
                    Toast.makeText(innerContext, "Dir not found", Toast.LENGTH_LONG).show();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }, INIT_DELAY);*/
    }

    public void onStart() {
        super.onStart();
        MediaController mediaController= new MediaController(innerContext);
        mediaController.setAnchorView(videoView);
        //videoView.setMediaController(mediaController);
        videoView.requestFocus();

        Log.v(TAG, "playVideo!!!!!!!!!!!!!!!!!!");
        playVideo();
    }

    private void playVideo() {

        videoFolderPath = new File(AppConstants.AdVideosPath);
        System.out.println("video folder files: " + videoFolderPath.listFiles().length);

        video_array = new String[videoFolderPath.listFiles().length];

        for(int count = 0; count < video_array.length; count++) {
            video_array[count] = videoFolderPath.listFiles()[count].getAbsolutePath();
            System.out.println("video " + count + " : " + videoFolderPath.listFiles()[count].getAbsolutePath());
        }

        if(video_array.length > 0) {
            videoFile = new File(video_array[currentVideoPosition]);
            if (videoFile.exists()) {
                //specify the location of media file
                Uri uri = Uri.parse(video_array[currentVideoPosition]);
                videoView.setVideoURI(uri);
                videoView.start();
                if(video_array.length > 1 ) {
                    currentVideoPosition = currentVideoPosition + 1;
                }
            } else {
                System.out.println("video not exists");
            }

            videoView.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
                @Override
                public void onCompletion(MediaPlayer mp) {

                    //if (!deleteCurrentVideo) {
                        startNextVid();
                    /*} else {
                        deleteVideoFile(video_array[currentVideoPosition]);
                        deleteCurrentVideo = false;
                        startNextVid();
                    }*/
                }
            });
        }
    }

    private void startNextVid() {
        if(video_array.length > 1 ) {
            videoFile = new File(video_array[currentVideoPosition]);
            if (videoFile.exists()) {
                //System.out.println("Video Playing : " + video_array[currentVideoPosition]);
                videoView.stopPlayback();
                uri = Uri.parse(video_array[currentVideoPosition]);
                videoView.setVideoURI(uri);
                videoView.start();
                if (currentVideoPosition == video_array.length - 1) {
                    currentVideoPosition = 0;
                } else {
                    currentVideoPosition = currentVideoPosition + 1;
                }
                //System.out.println("Video Position : " + currentVideoPosition);
            } else {
                // System.out.println("Video not exist");
            }
        } else {
            //System.out.println("Video Playing : " + video_array[currentVideoPosition]);
            videoView.stopPlayback();
            uri = Uri.parse(video_array[currentVideoPosition]);
            videoView.setVideoURI(uri);
            videoView.start();
        }
    }

    private Bitmap getBitmapFromPath(String filePath) throws FileNotFoundException, Exception{
        File imgFile = new  File(filePath);

        if(imgFile.exists()){

            Bitmap bitmap = BitmapFactory.decodeFile(imgFile.getAbsolutePath());

            return bitmap;
        }
        return null;
    }
}
